<?php

namespace STM\Match;

use STM\Competition\Season\Season;
use STM\Utils\Arrays;
use \Exception;
use \GetterOfTestingInstances;
use STM\StmFactory;

/**
 * Test class for MatchValidator.
 * Generated by PHPUnit on 2011-08-31 at 14:58:53.
 * @group match
 */
class MatchValidatorTest extends \PHPUnit_Framework_TestCase {

    private $all_matches;
    private $all_teams;
    private $competitions;
    private $valid_structure;
    private $playoff_serie;

    protected function setUp() {
        $this->competitions = array(
            'c' => GetterOfTestingInstances::get_competition(),
            'p' => GetterOfTestingInstances::getPlayoff(),
            's' => GetterOfTestingInstances::get_season(),
        );
        $this->valid_structure = array(
            'competition' => $this->competitions['c'],
            'home_team' => StmFactory::find()->Team->findById(1), 
            'away_team' => StmFactory::find()->Team->findById(2), 
            'datetime' => 'now',
            'round' => false,
            'serie' => false,
        );
        $this->playoff_serie = StmFactory::find()->PlayoffSerie->findById(1);
        $this->allMatches = getMatches(MatchSelection::ALL_MATCHES);
        $this->all_teams = getFirst_instances(StmFactory::find()->Team->findAll());
        MatchValidator::init();
    }

    public function test_create_playoff() {        
        // serie must be instanceof PlayoffSerie
        $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('match', new Exception()));        
        if ($this->playoff_serie && $this->competitions['p']) {
            $this->valid_structure['serie'] = $this->playoff_serie;
            $this->valid_structure['competition'] = StmFactory::find()->Competition->findById($this->playoff_serie->getIdPlayoff());
            // teams must be from serie
            $team_1 = StmFactory::find()->Team->findById($this->playoff_serie->getIdTeam1());
            $team_2 = StmFactory::find()->Team->findById($this->playoff_serie->getIdTeam2());            
            foreach ($this->all_teams as $team) {
                if (!in_array($team->getId(), array($team_1->getId(), $team_2->getId()))) {
                    $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('home_team', $team));
                    $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('away_team', $team));
                }
            }
            // new match can be created only if serie is not closed (next serie is not generated)
            $this->valid_structure['home_team'] = $team_1;
            $this->valid_structure['away_team'] = $team_2;
            if (is_null($this->playoff_serie->getIdNextSerie())) {
                $this->valid_structure['datetime'] = '';// if playoff has set start/end date and date was out of rage -> error
                parent::assertTrue(MatchValidator::checkCreate($this->valid_structure));
            } else {
                $this->assert_bad_arguments('checkCreate', $this->valid_structure);
            }
        }
        // update is same, only change is that match from closed serie can be updated (switch teams or change date)
    }

    public function test_create_season() {
        $this->valid_structure['competition'] = $this->competitions['s'];        
        if ($this->competitions['s']) {
            // round must be number from <1, maxRoundInSeason>            
            $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('round', -1));
            $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('round', 0));
            $this->assert_bad_arguments('checkCreate', $this->get_modified_structure('round', $this->competitions['s']->getMaxRound() + 1));;            
            # advanced tests
            $teams = Arrays::getAssocArray($this->competitions['s']->getTeams(), 'getId');
            $ms = array(
                'matchType' => \STM\Match\MatchSelection::PLAYED_MATCHES,
                'loadScores' => false,
                'loadPeriods' => false,
                'competition' => $this->competitions['s'],
                'seasonRound' => 1,
            );
            $matches_first_round = StmFactory::find()->Match->find($ms);
            // team can be only 1x in season round
            foreach ($matches_first_round as $played_match) {
                $this->assert_bad_arguments('checkCreate', $this->get_rebuilded_valid_structure(array(
                    'round' => 1,
                    'home_team' => $teams[$played_match->getIdTeamHome()],
                    'away_team' => $teams[$played_match->getIdTeamAway()],
                )));
                $this->assert_bad_arguments('checkCreate', $this->get_rebuilded_valid_structure(array(
                    'round' => 1,
                    'home_team' => $teams[$played_match->getIdTeamAway()],
                    'away_team' => $teams[$played_match->getIdTeamHome()],
                )));
            }
            // plus teams can play with each other max. season periods
        }
    }

    public function testCheck_create() {
        $this->assert_basic_attributes('checkCreate');
    }

    public function testCheck_update() {
        // basic attributes
        MatchValidator::setMatch(StmFactory::find()->Match->findById (1));// otherwise always false because object is not set
        $this->assert_basic_attributes('checkUpdate');
        // at least one attribute must be different
        foreach ($this->allMatches as $match) {
            MatchValidator::setMatch($match);
            $same_values = array(
                'home_team' => StmFactory::find()->Team->findById($match->getIdTeamHome()), 
                'away_team' => StmFactory::find()->Team->findById($match->getIdTeamAway()), 
                'datetime' => $match->getDate()->__toString(),
                'round' => $match->getRound(),
                'serie' => $match->getIdSerie() ? StmFactory::find()->PlayoffSerie->findById($match->getIdSerie()) : false,
            );
            $this->assert_bad_arguments('checkUpdate', $same_values);
            // after change date -> OK
            if ($same_values['datetime']) {
                $same_values['datetime'] .= ' + 2 seconds';// + 2 seconds
                parent::assertTrue(MatchValidator::checkUpdate($same_values));
            }
            MatchValidator::resetMatch();
        }
    }


    /** Check basic attributes used for all competition types (competition, home_team, away_team, datetime) */
    private function assert_basic_attributes($method_name) {        
        // argument must be array with keys competition, home_team, away_team, datetime, round, serie
        $this->assert_bad_arguments($method_name, null);
        $this->assert_bad_arguments($method_name, new Exception());
        // match must be instanceof Competition
        $this->assert_bad_arguments($method_name, $this->get_modified_structure('match', null));
        // datetime must be empty or string that can be converted to date
        $this->assert_bad_arguments($method_name, $this->get_modified_structure('datetime', array()));
        // teams must be instanceof Team 
        $this->assert_bad_arguments($method_name, $this->get_modified_structure('home_team', new Exception()));
        $this->assert_bad_arguments($method_name, $this->get_modified_structure('away_team', array()));        

        foreach ($this->competitions as $competition) {
            if (!($competition instanceof Competition)) {
                continue;
            }
            // round and serie can be set only in Season or Playoff
            if ($competition instanceof Season) {
                $this->assert_bad_arguments($method_name, $this->get_modified_structure('serie', $this->playoff_serie));
            } else if ($competition instanceof Playoff) {
                $this->assert_bad_arguments($method_name, $this->get_modified_structure('round', 1));
            } else {
                $this->assert_bad_arguments($method_name, $this->get_modified_structure('round', 1));
                $this->assert_bad_arguments($method_name, $this->get_modified_structure('serie', $this->playoff_serie));
            }
            // datetime must be from interval of competition start/end dates if they are set
            $this->valid_structure['competition'] = $competition;                        
            $hour_before_start_date = $competition->getDateStart()->isValid() ? "{$competition->getDateStart()->__toString()} - 1 hour" : null;
            $hour_after_end_date = $competition->getEndStart()->isValid() ? "{$competition->getEndStart()->__toString()} + 1 hour" : null;
            if ($hour_before_start_date) {
                $this->assert_bad_arguments($method_name, $this->get_modified_structure('datetime', $hour_before_start_date));
            }
            if ($hour_after_end_date) {
                $this->assert_bad_arguments($method_name, $this->get_modified_structure('datetime', $hour_after_end_date));
            }
            foreach ($this->all_teams as $team) {
                if (!($this->competitions['c'] instanceof Competition)) {
                    break;
                }
                // teams must be from competition
                if (!$this->competitions['c']->isTeamFromCompetition($team)) {
                    $this->assert_bad_arguments($method_name, $this->get_modified_structure('home_team', $team));
                    $this->assert_bad_arguments($method_name, $this->get_modified_structure('away_team', $team));
                }
                // teams must be different
                $this->valid_structure['home_team'] = $team;
                $this->valid_structure['away_team'] = $team;
                $this->assert_bad_arguments($method_name, $this->valid_structure);
            }
        }
    }

    private function get_rebuilded_valid_structure($values) {
        $attributes = $this->valid_structure;
        foreach ($values as $key => $new_value) {
            $attributes[$key] = $new_value;
        }
        return $attributes;
    }

    private function get_modified_structure($key, $new_value) {
        $attributes = $this->valid_structure;
        $attributes[$key] = $new_value;
        return $attributes;
    }

    private function assert_bad_arguments($method, $data) {
        MatchValidator::init();
        parent::assertFalse(MatchValidator::$method($data));
        MatchValidator::init();
    }

}

?>
